#!/bin/sh
# qemu_menu.sh - version 0.7 - written by Michael Thorberger
# manage qemu virtual machines with a menu
config="$HOME/.config/qemu_menu.conf"

#shellcheck disable=SC1091,SC2034,SC2154,SC2046,SC2086
. "$SCRIPTS"/functions/text-center.func || exit 1
. "$SCRIPTS"/functions/awk-menu.func || exit 1
. "$SCRIPTS"/functions/text-box.func || exit 1
. "$SCRIPTS"/functions/colors.func || exit 1
if [ ! -f "$config" ]; then
  cat > "$config" <<EOF
# this file was generated by ${script_name}
# qemu_menu uses this file to search for existing vm's
# every line that does not start with a '#' will be
# treated as a directory and searched for .qemu files
$HOME/.local/vm
EOF
fi
script_name="$(echo "$0" | sed "s:$HOME:~:")"
logo="
  ${clr7}  ██████▍   █████▍  █████████████   ████  ████  █████████████▍   █████▍  ████████▍  ████  ████${clr_end}
  ${clr7} ███▒▒███  ███▒▒██▍▒▒███▒▒███▒▒███ ▒▒███ ▒███  ▒▒███▒▒███▒▒███  ███▒▒██▍▒▒███▒▒███ ▒▒███ ▒███ ${clr_end}
  ${clr7}▒███ ▒███ ▒███████  ▒███ ▒███ ▒███  ▒███ ▒███   ▒███ ▒███ ▒███ ▒███████  ▒███ ▒███  ▒███ ▒███ ${clr_end}
  ${clr7}▒███ ▒███ ▒███▒▒▒   ▒███ ▒███ ▒███  ▒███ ▒███   ▒███ ▒███ ▒███ ▒███▒▒▒   ▒███ ▒███  ▒███ ▒███ ${clr_end}
  ${clr7}▒▒███████ ▒▒██████  █████▒███ █████ ▒▒████████  ████▍▒███ ████▍▒▒██████  ████▍▐████ ▒▒████████${clr_end}
  ${clr7} ▒▒▒▒▒███  ▒▒▒▒▒▒  ▒▒▒▒▒ ▒▒▒ ▒▒▒▒▒   ▒▒▒▒▒▒▒▒  ▒▒▒▒▒ ▒▒▒ ▒▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒   ▒▒▒▒▒▒▒  ${clr_end}
  ${clr7}     ▒███ ${clr_end}
  ${clr7}     ▒████${clr_end}
  ${clr7}     ▒▒▒▒ ${clr_end}\\n"
text_box_opt="-t $(printf "%s" "$0" | sed "s:$HOME:~:") -tpos 10"
awk_menu_help="$(text_box $text_box_opt "$(echo "\\nPess h to go back\\n")" )
$(echo "
  This script will create a '.qemu' file for every virtual machine.
  Those files are then used by this script to generate a qemu command.\\n
  The default directory where this script will search
  for '.qemu' files is '~/.local/vm', other directories
  can be specified in ${clr3}$(echo "$config" | sed "s:$HOME:~:")${clr_end}
")"

# find all files in vm_dir that have '.qemu' at the end of the name
get_vm_list() {
  unset vm_list
  if [ -f "$config" ]; then
    for dir in $(grep -v '#' "$config"); do
      vm_list="${vm_list}\\n${clr2}$(find "$dir" -type f -name '*\.qemu' -printf ${clr2}${txt_underlined}%p${txt_normal}\\n)${clr_end}"
    done
    vm_list="$(echo "$vm_list" | sed "s:/home/$USER:~:" | sort -V | grep -v "^$")"
  else
    printf "Config file not found: %s\n" "$config"
  fi
}

get_cpu_host() {
  if [ -z "$host_arch" ]; then
    echo "Error: failed to read cpu architecture"; exit 1
  elif [ ! "$vm_arch" ] || [ ! "$(command -v $vm_arch)" ]; then
    echo "Error: command not found: $vm_arch"; exit 1
  fi
  if [ "qemu-system-$host_arch" = "$vm_arch" ]; then
    cpu_host='-cpu host'
  else
    unset cpu_host
  fi
}

get_kvm() {
  if [ -e /dev/kvm ] && [ "$cpu_host" ]; then
    kvm='-enable-kvm'
  else
    unset kvm
    echo ${clr5}"Warning: ${clr3}kvm not supported, you may experience poor performance"${clr_end}
    sleep 3
  fi
}

check_usr_input() {
#make sure there are only alphanumeric characters and '-' or '_' except at the beginning or end
  unset input_check ; unset strlen ; unset usr_input
  usr_input="$@"
  str_len="$(echo "$usr_input" | awk '{print length}')"
  if [ "$str_len" -gt 0 ] && [ "$str_len" -lt 256 ]; then
    if [ -z $(printf "%s" "$usr_input" | tr -d _- | tr -d '[:alnum:]') ] \
    && ! echo "$usr_input" | cut -b 1,"$str_len" | grep -e [-_];   then
      input_check="OK"
    fi
  fi
}

set_name() {
  clear
  text_box $text_box_opt "$logo"
  printf "Enter a name for this vm: "
  read -r new_vm_name
  check_usr_input "$new_vm_name"
  if [ "$input_check" = "OK" ]; then
    vm_name="$new_vm_name"
  else
    echo "invalid name" && sleep 1
  fi
  unset new_vm_name
  awk_menu_line_number=2
}

set_arch() {
  awk_menu_tmsg="$(text_box $text_box_opt "$logo" "                  ${txt_bold}Select architecture:")"
  awk_menu_line_number=2
  input_text="$(text_center "i386
x86_64
 arm")
${clr4} < back to main menu${clr_end}"
  awk_menu_keys='q'
  awk_menu -q "$input_text"
  new_arch="$(echo "$awk_menu_output" | strip_color)"
  awk_menu_line_number=3
  if [ "$awk_menu_key_press" = 'q' ] || [ -z "$new_arch" ] \
  || [ "$vm_arch" = 'qemu-system-' ] || [ "$vm_arch" = 'qemu-system- < back to main menu' ]; then
    return
  fi
  vm_arch="qemu-system-$new_arch"
  get_cpu_host
  get_kvm
}

set_cpu_cores() {
  awk_menu_tmsg="$(text_box $text_box_opt "$logo" "$(text_center ${txt_bold}How many cpu cores?)")"
  cpu_list="$(text_center "$(seq 1 $((cores_per_socket -1)))")"
  if [ "$cpu_cores" ]; then
    awk_menu_line_number="$cpu_cores"
  else
    awk_menu_line_number=1
  fi
  awk_menu_keys='q'
  awk_menu -q "$cpu_list\\n${clr4} < back to main menu${clr_end}"
  ans="$(echo "$awk_menu_output" | strip_color)"
  awk_menu_line_number=4
  if [ ! "$ans" ] || [ "$awk_menu_key_press" = 'q' ] || [ "$ans" = " < back to main menu" ]; then
    return
  else
    cpu_cores="$ans"
  fi
}

set_cpu_threads() {
  awk_menu_tmsg="$(text_box $text_box_opt "$logo" "$(text_center ${txt_bold}How many threads per core?)")"
  cpu_list="$(text_center "$(seq 1 "$threads_per_core")")"
  if [ "$cpu_threads" ]; then
    awk_menu_line_number="$cpu_threads"
  else
    awk_menu_line_number="$threads_per_core"
  fi
  awk_menu -q "$cpu_list\\n${clr4} < back to main menu${clr_end}"
  ans="$(echo "$awk_menu_output" | strip_color)"
  awk_menu_line_number=5
  if [ ! "$ans" ] || [ "$awk_menu_key_press" = 'q' ] || [ "$ans" = " < back to main menu" ]; then
    return
  else
    cpu_threads="$ans"
  fi
}

set_ram() {
  awk_menu_tmsg="$(text_box $text_box_opt "$logo" "$(text_center ${txt_bold}How much RAM?)")"
  ram_free="$(free --giga | awk '/Mem/ {print $4}')"
  ram_list="256M\\n512M\\n$(seq 1 "$ram_free" | sed 's/$/G/g')"
  ram_list="$(text_center "$ram_list")"
  awk_menu_line_number=2
  awk_menu -q "$ram_list\\n${clr4} < back to main menu${clr_end}"
  ans="$(echo "$awk_menu_output" | strip_color)"
  awk_menu_line_number=6
  if [ ! "$ans" ] || [ "$awk_menu_key_press" = 'q' ] || [ "$ans" = " < back to main menu" ]; then
    return
  else
    ram="$ans"
  fi
}

get_free_space() {
  for i in $(lsblk -lnpo MOUNTPOINT | awk '($1) {print $1}' | sort -r); do
    if echo "$vm_dir" | grep -q "$i"; then
      host_fs_mp="$i"
    fi
  done
  host_fs_dev="$(lsblk -lnpo NAME,MOUNTPOINT | awk -v mp="$host_fs_mp" '{if ($2 == mp) {print $1}}')"
  free_space="$(lsblk -lnpo FSAVAIL "$host_fs_dev" | awk '{gsub(/ /,""); print $1}')"
  if echo "$free_space" | grep \\. && echo "$free_space" | grep -v "[K|M]"; then
    if echo "$free_space" | grep "[G]"; then
      free_gb="$(echo "$free_space" | awk -F '.' '{print $1}')"
    elif echo "$free_space" | grep "[T]"; then
      free_gb="$(($(echo "$free_space" | awk -F '.' '{print $1}')*1000))"
    fi
  fi
  if [ "$free_gb" -lt 1 ]; then
    echo "Error" && exit 1
  fi
}

set_storage() {
  get_free_space
  vm_file_list="${clr2}$(find "$vm_dir" -maxdepth 1 -type f -iname "*.qcow2" | sort)${clr_end}"
  awk_menu_tmsg="$(text_box $text_box_opt "$logo                  vm_dir: ${clr4}$(echo "$vm_dir" | sed "s:/home/$USER:~:")
                  free space on ${clr4}$host_fs_dev${clr5}: ${clr1}${txt_bold}$free_space${clr_end}")"
  menu_text="$(echo "create new qcow2 file\\n$vm_file_list\\nback" | strip_color | tr -s '\n')"
  awk_menu -q "$menu_text"
  selection="$(echo "$awk_menu_output" | strip_color)"
  awk_menu_line_number=6
  if [ ! "$selection" ] || [ "$awk_menu_key_press" = 'q' ] || [ "$selection" = "back" ]; then
    return
  else
    case "$selection" in
    "create new qcow2 file") awk_menu_tmsg="$logo                  vm_dir: ${clr4}$(echo "$vm_dir" | sed "s:/home/$USER:~:")
                  free space on ${clr4}$host_fs_dev${clr5}: ${clr1}${txt_bold}$free_space${clr_end}"
                             text_box $text_box_opt "$awk_menu_tmsg"
                             echo "How large shall this vm be? (GB)"
                             printf "Enter a integer number from 1 to %s: " "$(echo "$free_space" | cut -d '.' -f1)"
                             unset int
                             read -r int
                             if [ "$int" -ge 1 ] && [ "$int" -le "$(echo "$free_space" | cut -d '.' -f1)" ]; then
                               vm_file_size="$int"
                               if [ ! -d "$vm_dir" ]; then
                                 mkdir -vp "$vm_dir"
                               fi
                               if [ ! "$vm_name" ]; then
                                 while [ ! "$vm_name" ]; do
                                   set_name
                                 done
                               fi
                               if [ -f  "${vm_dir}/${vm_name}.qcow2" ]; then
                                 echo  "${vm_dir}/${vm_name}.qcow2 already exists. Change the name if you want to create a new file."
                                 sleep 2; return 0
                               fi
                               qemu-img create -f qcow2 ${vm_dir}/${vm_name}.qcow2 "$vm_file_size"G && \
                               storage="-hda ${vm_dir}/${vm_name}.qcow2"
                               echo "${vm_dir}/${vm_name}.qcow2 has been created" && sleep 2
                             fi;;
    "back") return 0;;
    esac
  fi
  if [ -f "$selection" ]; then
    storage="-hda $selection"
  fi
}

set_iso() {
  iso_list="$(find "$HOME" -maxdepth 4 -type f -iname "*.iso" | sort)
$(find "/home/snapshot" -maxdepth 4 -type f -iname "*.iso" | sort)"
  awk_menu_tmsg="$(text_box $text_box_opt "${txt_b}Select iso file${txt_n}")"
  awk_menu_line_number=1
  awk_menu -q "$iso_list" "\\n${clr4}unset${clr_end}\\nback"
  if [ ! "$selection" ] || [ "$awk_menu_key_press" = 'q' ] || [ "$selection" = "back" ]; then
    return
  else
    iso="$(echo "$awk_menu_output" | strip_color)"
  fi
  if [ "$iso" = "unset" ]; then
    unset iso
  fi
  if [ ! "$(echo "$iso" | grep '^-cdrom')" ]; then
    iso="-cdrom $iso"
  fi
}

set_custom_options() {
  clear
  text_box $text_box_opt "$logo"
  printf "Enter custom options for this vm: "
  read -r custom_opt
  awk_menu_line_number=1
}

create_vm() {
  load_default_settings
  if [ "$(grep -v '#' "$config" | wc -l)" -gt "1" ]; then
    awk_menu_tmsg="$(text_box $text_box_opt "$(text_center "Select vm_dir")")"
    vm_dir="$(awk_menu "$(grep -v '#' "$config")" | strip_color)"
  elif [ "$(grep -v '#' "$config" | wc -l)" = "1" ]; then
    vm_dir="$(grep -v '#' "$config")"
  fi
  if [ ! -d "$vm_dir" ] || [ ! -L "$vm_dir" ]; then
    mkdir -p "$vm_dir" || exit 1
  fi
  awk_menu_line_number=1
  while [ -z "$vm_list" ] ; do
    while [ -z "$vm_name" ]; do
      set_name
    done
    qemu_menu
    get_vm_list
  done
}

save_vm() {
  while [ ! "$vm_name" ]; do
    set_name
  done
  if [ ! -d "$vm_dir" ]; then
    mkdir -pv "$vm_dir"
  fi
  save_file="$vm_dir/$vm_name.qemu"
  echo "#this file was created by $0 - $(date '+%d %b %Y %H:%M:%S')" > "$save_file"
  echo "NAME=${vm_name}" >> "$save_file"
  echo "ARCH=${vm_arch}" >> "$save_file"
  echo "KVM=${kvm}" >> "$save_file"
  echo "CPU_HOST=${cpu_host}" >> "$save_file"
  echo "CPU_CORES=${cpu_cores}" >> "$save_file"
  echo "CPU_THREADS=${cpu_threads}" >> "$save_file"
  echo "RAM=${ram}" >> "$save_file"
  echo "HDD=${storage}" >> "$save_file"
  echo "ISO=${iso}" >> "$save_file"
  echo "OPT=${custom_opt}" >> "$save_file"
  get_vm_list
}

unset_vm_vars() {
  unset save_file
  unset vm_name
  unset vm_arch
  unset kvm
  unset cpu_host
  unset cpu_cores
  unset cpu_threads
  unset ram
  unset storage
  unset iso
  unset custom_opt
}

load_vm() {
  if [ ! "$1" ]; then
    printf "%s function load_vm was called without an argument.\\n" "$0"
    exit 1
  else
    unset_vm_vars
    vm_dir="$(echo "$1" | awk -F '/' '{OFS="/"; $NF=""}{print substr($0, 1, length($0)-1)}' | sed "s:~:$HOME:")"
    save_file="$(echo "$1" | sed "s:~:$HOME:")"
    vm_name="$(awk -v FS='NAME=' '/NAME=/ {print $2}' "$save_file")"
    vm_arch="$(awk -v FS='ARCH=' '/ARCH=/ {print $2}' "$save_file")"
    kvm="$(awk -v FS='KVM=' '/KVM=/ {print $2}' "$save_file")"
    cpu_host="$(awk -v FS='CPU_HOST=' '/CPU_HOST=/ {print $2}' "$save_file")"
    cpu_cores="$(awk -v FS='CPU_CORES=' '/CPU_CORES=/ {print $2}' "$save_file")"
    cpu_threads="$(awk -v FS='CPU_THREADS=' '/CPU_THREADS=/ {print $2}' "$save_file")"
    ram="$(awk -v FS='RAM=' '/RAM=/ {print $2}' "$save_file")"
    storage="$(awk -v FS='HDD=' '/HDD=/ {print $2}' "$save_file")"
    iso="$(awk -v FS='ISO=' '/ISO=/ {print $2}' "$save_file")"
    custom_opt="$(awk -v FS='OPT=' '/OPT=/ {print $2}' "$save_file")"
  fi
}

pretty_cmd() {
  if [ "$vm_arch" ]; then
    echo "${clr1}${vm_arch}"
  fi
  if [ "$cpu_host" ]; then
    echo "                          ${clr1}${cpu_host}"
  fi
  if [ "$kvm" ]; then
    echo "                          ${clr1}${kvm}"
  fi
  if [ "$cpu_cores" ] && [ "$cpu_threads" ]; then
  echo "                          ${clr1}-smp cores=$cpu_cores,threads=$cpu_threads"
  fi
  if [ "$ram" ]; then
  echo "                          ${clr1}-m $ram"
  fi
  if [ "$storage" ]; then
  echo "                          ${clr1}${storage}"
  fi
  if [ "$iso" ]; then
  echo "                          ${clr1}${iso}"
  fi
  if [ "$custom_opt" ]; then
  echo "                          ${clr1}${custom_opt}"
  fi
}

get_qemu_cmd() {
  VM_CMD="${vm_arch} ${cpu_host} ${kvm} -smp cores=$cpu_cores,threads=$cpu_threads -m ${ram} -display gtk,zoom-to-fit=on,grab-on-hover=on ${storage} ${iso} ${custom_opt}"
}

start_qemu() {
  echo "$VM_CMD"
  if [ "$cpu_host" = '-cpu host' ] || [ "$kvm" = '-enable-kvm' ]; then
    sudo $VM_CMD &
  else
    $VM_CMD &
  fi
#  VM_PID="$!"
}

qemu_menu() {
  get_qemu_cmd
  if [ -f "$save_file" ]; then
    awk_menu_tmsg="$(cursor_move_up 2)$(cursor_move_right 18)${txt_b}file:${txt_n} ${clr1}$(echo "$save_file" | sed "s:/home/$USER:~:")
$(cursor_move_right 15)${txt_b}command:${txt_n} $(pretty_cmd)"
    awk_menu_tmsg_len="$((11+$(pretty_cmd | wc -l)))"
  else
    unset awk_menu_tmsg
    awk_menu_tmsg_len="13"
  fi
  awk_menu_tmsg="$(text_box $text_box_opt "$logo" "$awk_menu_tmsg")"
  input_text="   ${clr5}name:${clr_end} $vm_name
   ${clr5}architecture:${clr_end} $(echo "$vm_arch" | awk -F '-' '{print $3}')
   ${clr5}cpu cores:${clr_end} $cpu_cores
   ${clr5}threads per core:${clr_end} $cpu_threads
   ${clr5}memory:${clr_end} $ram
   ${clr5}storage:${clr_end} $storage
   ${clr5}iso:${clr_end} $iso
   ${clr5}custom options:${clr_end} $custom_opt
${clr2}   save this setup${clr_end}
${clr4} < back to main menu${clr_end}"

  if [ -f "$save_file" ]; then
    input_text="${clr2}START${clr_end}\\n$input_text"
  else
    input_text="$input_text\\n${clr4}START${clr_end}"
  fi
  awk_menu_keys='q'
  awk_menu -q "$input_text"
  selection="$(echo "$awk_menu_output" | strip_color)"
  unset awk_menu_tmsg_len
  if [ "$awk_menu_key_press" = 'q' ]; then
    vm_menu
  else
  if [ ! "$selection" ]; then
    exit 0
  elif echo "$selection" | grep -q "^name:"; then
    set_name
  elif echo "$selection" | grep -q "^architecture:"; then
    set_arch
  elif echo "$selection" | grep -q "^cpu cores:"; then
    set_cpu_cores
  elif echo "$selection" | grep -q "^threads per core:"; then
    set_cpu_threads
  elif echo "$selection" | grep -q "^memory:"; then
    set_ram
  elif echo "$selection" | grep -q "^storage:"; then
    set_storage
  elif echo "$selection" | grep -q "^iso:"; then
    set_iso
  elif echo "$selection" | grep -q "^custom options:"; then
    set_custom_options
  elif echo "$selection" | grep -q "save this setup"; then
    save_vm
  elif echo "$selection" | grep -q "^ < back to main menu$"; then
    unset_vm_vars
    vm_menu
  fi
fi
}

menu_loop(){
  unset selection
  while [ "$selection" != "START" ]; do
    qemu_menu
  done
}

vm_menu() {
  get_vm_list
  if ! echo "$vm_list" | grep -q '.qemu'; then
    awk_menu_tmsg="$(text_box $text_box_opt "$logo" $(text_center "Did not find any vm's"))"
    awk_menu_keys="q"
    awk_menu -q "${clr4}Create new VM${clr_end}\\n${clr1}Exit${clr_end}"
    selection="$(echo "$awk_menu_output" | strip_color)"
    if [ "$awk_menu_key_press" = 'q' ]; then
      selection='Exit'
    fi
    case "$selection" in
      'Create new VM') menu_loop;;
               'Exit') clear; exit 0;;
    esac
  else
    awk_menu_tmsg="$(text_box $text_box_opt "$logo" "$(cursor_save)$(cursor_move_up 2)$(cursor_move_right 18)${clr1}A simple script to manage virtual machines.${clr_end}$(cursor_restore)" "                 Keys:   ${clr5}b ${clr1}boot vm         ${clr5}e ${clr1}edit file${clr_end}
                           ${clr5}c ${clr1}create vm       ${clr5}h ${clr1}help${clr_end}
                           ${clr5}d ${clr1}delete vm       ${clr5}q ${clr1}quit${clr_end}")"
    awk_menu_keys="bcdeq"
    awk_menu -q "$(echo "$vm_list\\n${clr4}Create new VM\\n${clr5}Exit${clr_end}")"
    selection="$(echo "$awk_menu_output" | strip_color)"
    if [ "$awk_menu_key_press" ]; then
      case "$awk_menu_key_press" in
        'b') load_vm "$selection"; get_qemu_cmd; start_qemu; unset selection;;
        'c') create_vm;;
        'd') awk_menu_tmsg="$(text_box $text_box_opt "$logo" "$(text_center "${clr1}really delete $selection?")")"
           unset ans
           ans="$(awk_menu "$(text_center "yes\\nno")")"
           if [ "$ans" = "yes" ] &&  [ -f "$(echo "$selection" | sed "s:~:$HOME:")" ]; then
             rm -v "$(echo "$selection" | sed "s:~:$HOME:")"
           fi
           unset selection; break; script_start;;
        'e') selected_file="$(echo "$selection" | sed "s:~:$HOME:")"
           if [ -f "$selected_file" ]; then
             $EDITOR "$selected_file"
           fi
           unset selection
           unset selected_file
           break; script_start;;
        'q') clear; exit 0;;
      esac
    elif [ -f "$(echo "$selection" | sed "s:~:$HOME:")" ]; then
      load_vm "$selection"
      menu_loop
    elif [ "$selection" = "Create new VM" ]; then
      menu_loop
    elif [ "$selection" = "Exit" ]; then
      clear; exit 0
    fi
  fi
}

load_default_settings() {
  vm_dir="$(grep -v '#' "$config" | head -n1)"
  vm_arch="qemu-system-$host_arch"
  cpu_threads="$threads_per_core"
  if [ "$cores_per_socket" -ge 4 ]; then
    cpu_cores=2
  else
    cpu_cores=1
  fi
  if  [ -z "$ram" ] || [ "${ram%G}" -ge 4 ]; then
    ram=2G
  elif [ "${ram%G}" -le 1 ]; then
    ram=512M
  elif [ "${ram%G}" -lt 4 ]; then
    ram=1G
  fi
  get_cpu_host
  get_kvm
}

script_init() {
  host_arch="$(lscpu | awk '/Architecture:/ {print $2}' | grep "[i386|x86_64|arm]")"
  threads_per_core="$(lscpu | awk '/Thread\(s\) per core/ {print $4}')"
  cores_per_socket="$(lscpu | awk '/Core\(s\) per socket/ {print $4}')"
  ram="$(($(free --giga | awk '/^Mem/ {print $7}')-1))"
  if [ "$ram" = "1" ] || [ "$ram" = "0" ] || [ "$ram" = "-1" ]; then
    awk_menu_tmsg="$(text_box $text_box_opt "  Only ${clr1}$(free --mega | awk '/Mem/ {print $4}') MB${clr7} RAM available
    Are you sure that you want to do this?")"
    awk_menu_line_number=2
    selection=$(awk_menu "Continue\\nExit")
    if [ "$selection" = "Exit" ]; then
      unset_vm_vars
      exit 0
    fi
  fi
  load_default_settings
}

script_init
vm_menu
if [ "$selection" = "START" ]; then
  clear
  start_qemu
fi
exit 0
